#include <IV-look/kit.h>
#include <InterViews/background.h>
#include <InterViews/box.h>
#include <InterViews/glue.h>
#include <InterViews/place.h>
#include <InterViews/session.h>
#include <InterViews/style.h>
#include <InterViews/window.h>
#include <stdio.h>

class App {
public:
    void msg();
};

declare(ActionCallback,App)
implement(ActionCallback,App)

void App::msg() {
    printf("hi mom!\n");
}

int main(int argc, char** argv) {
    Session* session = new Session("Himom", argc, argv);
    Style* style = session->style();
    Kit* kit = Kit::instance();
    App* a = new App;
    TelltaleGroup* group = new TelltaleGroup;
    session->run_window(
	new ApplicationWindow(
	    new Background(
		new Margin(
		    new LRBox(
			new VCenter(
			    kit->simple_toggle_button(
				"Toggle me", style,
				new ActionCallback(App)(a, &App::msg)
			    ),
			    0.5
			),
			new HGlue(15.0),
			new VCenter(
			    new TBBox(
				new VCenter(
				    kit->simple_radio_button(
					group, "One", style, nil
				    ),
				    1.0
				),
				kit->simple_radio_button(
				    group, "Two", style, nil
				)
			    ),
			    0.5
			)
		    ),
		    10.0
		),
		style->flat()
	    )
	)
    );
}
